/*
 * 5799-WZQ (C) COPYRIGHT = NONE
 * LICENSED MATERIALS - PROPERTY OF IBM
 */
/* $Header:mknod.c 12.0$ */
/* $ACIS:mknod.c 12.0$ */
/* $Source: /ibm/acis/usr/src/etc/RCS/mknod.c,v $ */

#ifndef lint
static char *rcsid = "$Header:mknod.c 12.0$";
#endif

#ifndef lint
static char *sccsid = "@(#)mknod.c	4.2 (Berkeley) 8/28/85";
#endif not lint

#include <stdio.h>

main(argc, argv)
	int argc;
	char **argv;
{
	int m, a, b;

	if(argc != 5) {
		fprintf(stderr,"arg count\n");
		goto usage;
	}
	if(*argv[2] == 'b')
		m = 060666; else
	if(*argv[2] == 'c')
		m = 020666; else
		goto usage;
	a = number(argv[3]);
	if(a < 0)
		goto usage;
	b = number(argv[4]);
	if(b < 0)
		goto usage;
	if(mknod(argv[1], m, (a<<8)|b) < 0) {
		fprintf(stderr, "%s: ",argv[0]);
		perror(argv[1]);
	}
	exit(0);

usage:
	fprintf(stderr,"usage: %s name b/c major minor\n",argv[0]);
}

number(s)
char *s;
{
	int n, c;

	n = 0;
	while(c = *s++) {
		if(c<'0' || c>'9')
			return(-1);
		n = n*10 + c-'0';
	}
	return(n);
}
